package com.bsoft.api.service.Impl;

import com.bsoft.api.mapper.BlockValuesMapper;
import com.bsoft.api.mapper.DicDimMapper;
import com.bsoft.api.mapper.SerPageBlockRsMapper;
import com.bsoft.api.model.DicDim;
import com.bsoft.api.model.SerPageBlockRs;
import com.bsoft.api.service.BlockValuesService;
import org.apache.ibatis.binding.MapperMethod;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@Service
public class BlockValuesServiceImpl implements BlockValuesService {

    @Resource
    private SerPageBlockRsMapper serPageBlockRsMapper;
    @Resource
    private DicDimMapper dicDimMapper;
    @Resource
    private BlockValuesMapper blockValuesMapper;


        @Override
        public List<Map<String,Object>> getBlockValuesByPageID(Integer pageId,Integer disease,Integer doctor,Integer department,Integer time){
            Boolean isDisease = false;
            Boolean isDoctor = false;
            Boolean isDepartment = false;
            Boolean isTime = false;
            List<Map<String,Object>> list = new ArrayList<>();
            //根据pageId查询所有板块
            List<SerPageBlockRs> pageBlocklist =serPageBlockRsMapper.selectByPageId(pageId);
            //根据pageId查询所有维度
            List<DicDim> dimList = dicDimMapper.selectByPageid(pageId);
            //循环获取需要添加的维度查询条件
            for (DicDim data : dimList) {
                if(data.getDimField().equalsIgnoreCase("disease")){
                    isDisease=true;
                }
                if(data.getDimField().equalsIgnoreCase("doctor")){
                    isDoctor=true;
                }
                if(data.getDimField().equalsIgnoreCase("department")){
                    isDepartment=true;
                }
                if(data.getDimField().equalsIgnoreCase("time")){
                    isTime=true;
                }
            }
            //循环获取数据
            for (SerPageBlockRs data : pageBlocklist) {
                //获取表名
                String tableName = "VAL_BLOCK_VALUES_"+data.getBlockId();

                String whereSql = "where 1=1";

                //添加查询条件
                if(disease!=null&&isDisease){
                    whereSql+=String.format(" and disease='%s'",disease);
                }
                if(doctor!=null&&isDoctor){
                    whereSql+=String.format(" and doctor='%s'",doctor);
                }
                if(department!=null&&isDepartment){
                    whereSql+=String.format(" and department='%s'",department);
                }
                if(time!=null&&isTime){
                    whereSql+=String.format(" and time='%s'",time);
                }
                List<Map<String,Object>> dataList =blockValuesMapper.selectByWhere(tableName,whereSql);
                list.add(new HashMap<String,Object>(){
                    {
                        put(data.getBlockId().toString(),dataList);
                    }
                });
            }
            return  list;
        }


}
